TarOutputStream (Apache Ant API)
Keywords: org.apache.tools.tar.TarOutputStream class

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.tools.tar
Class TarOutputStream

    java.lang.Object
      java.io.OutputStream
          java.io.FilterOutputStream
              org.apache.tools.tar.TarOutputStream

All Implemented Interfaces:
  java.io.Closeable, java.io.Flushable

    public class TarOutputStream

extends java.io.FilterOutputStream

The TarOutputStream writes a UNIX tar archive as an OutputStream. Methods are provided to put entries, and then write their contents by writing to this stream using write().

Field Summary
`protected byte[]` | `assemBuf`
`protected int` | `assemLen`
`protected TarBuffer` | `buffer`
`protected long` | `currBytes`
`protected java.lang.String` | `currName`
`protected long` | `currSize`
`protected boolean` | `debug`
`static int` | `LONGFILE_ERROR` Fail if a long file name is required in the archive.
`static int` | `LONGFILE_GNU` GNU tar extensions are used to store long file names in the archive.
`static int` | `LONGFILE_TRUNCATE` Long paths will be truncated in the archive.
`protected int` | `longFileMode`
`protected byte[]` | `oneBuf`
`protected byte[]` | `recordBuf`

Fields inherited from class java.io.FilterOutputStream
`out`

Constructor Summary
`TarOutputStream(java.io.OutputStream os)` Constructor for TarInputStream.
`TarOutputStream(java.io.OutputStream os, int blockSize)` Constructor for TarInputStream.
`TarOutputStream(java.io.OutputStream os, int blockSize, int recordSize)` Constructor for TarInputStream.

Method Summary
`void` | `close()` Ends the TAR archive and closes the underlying OutputStream.
`void` | `closeEntry()` Close an entry.
`void` | `finish()` Ends the TAR archive without closing the underlying OutputStream.
`int` | `getRecordSize()` Get the record size being used by this stream's TarBuffer.
`void` | `putNextEntry(TarEntry entry)` Put an entry on the output stream.
`void` | `setBufferDebug(boolean debug)` Sets the debugging flag in this stream's TarBuffer.
`void` | `setDebug(boolean debugF)` Sets the debugging flag.
`void` | `setLongFileMode(int longFileMode)` Set the long file mode.
`void` | `write(byte[] wBuf)` Writes bytes to the current tar archive entry.
`void` | `write(byte[] wBuf, int wOffset, int numToWrite)` Writes bytes to the current tar archive entry.
`void` | `write(int b)` Writes a byte to the current tar archive entry.

Methods inherited from class java.io.FilterOutputStream
`flush`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### LONGFILE_ERROR

    public static final int LONGFILE_ERROR

  Fail if a long file name is required in the archive.

  See Also:
    Constant Field Values

### LONGFILE_TRUNCATE

    public static final int LONGFILE_TRUNCATE

  Long paths will be truncated in the archive.

  See Also:
    Constant Field Values

### LONGFILE_GNU

    public static final int LONGFILE_GNU

  GNU tar extensions are used to store long file names in the archive.

  See Also:
    Constant Field Values

### debug

    protected boolean debug

### currSize

    protected long currSize

### currName

    protected java.lang.String currName

### currBytes

    protected long currBytes

### oneBuf

    protected byte[] oneBuf

### recordBuf

    protected byte[] recordBuf

### assemLen

    protected int assemLen

### assemBuf

    protected byte[] assemBuf

### buffer

    protected TarBuffer buffer

### longFileMode

    protected int longFileMode

Constructor Detail

### TarOutputStream

    public TarOutputStream(java.io.OutputStream os)

  Constructor for TarInputStream.

  Parameters:
    `os` - the output stream to use

### TarOutputStream

    public TarOutputStream(java.io.OutputStream os,
                           int blockSize)

  Constructor for TarInputStream.

  Parameters:
    `os` - the output stream to use
    `blockSize` - the block size to use

### TarOutputStream

    public TarOutputStream(java.io.OutputStream os,
                           int blockSize,
                           int recordSize)

  Constructor for TarInputStream.

  Parameters:
    `os` - the output stream to use
    `blockSize` - the block size to use
    `recordSize` - the record size to use

Method Detail

### setLongFileMode

    public void setLongFileMode(int longFileMode)

  Set the long file mode. This can be LONGFILE_ERROR(0), LONGFILE_TRUNCATE(1) or LONGFILE_GNU(2). This specifies the treatment of long file names (names >= TarConstants.NAMELEN). Default is LONGFILE_ERROR.

  Parameters:
    `longFileMode` - the mode to use

### setDebug

    public void setDebug(boolean debugF)

  Sets the debugging flag.

  Parameters:
    `debugF` - True to turn on debugging.

### setBufferDebug

    public void setBufferDebug(boolean debug)

  Sets the debugging flag in this stream's TarBuffer.

  Parameters:
    `debug` - True to turn on debugging.

### finish

    public void finish()
                throws java.io.IOException

  Ends the TAR archive without closing the underlying OutputStream. The result is that the two EOF records of nulls are written.

  Throws:
    `java.io.IOException` - on error

### close

    public void close()
               throws java.io.IOException

  Ends the TAR archive and closes the underlying OutputStream. This means that finish() is called followed by calling the TarBuffer's close().

  Specified by:
    `close` in interface `java.io.Closeable`
  Overrides:
    `close` in class `java.io.FilterOutputStream`
  Throws:
    `java.io.IOException` - on error

### getRecordSize

    public int getRecordSize()

  Get the record size being used by this stream's TarBuffer.

  Returns:
    The TarBuffer record size.

### putNextEntry

    public void putNextEntry(TarEntry entry)
                      throws java.io.IOException

  Put an entry on the output stream. This writes the entry's header record and positions the output stream for writing the contents of the entry. Once this method is called, the stream is ready for calls to write() to write the entry's contents. Once the contents are written, closeEntry() MUST be called to ensure that all buffered data is completely written to the output stream.

  Parameters:
    `entry` - The TarEntry to be written to the archive.
  Throws:
    `java.io.IOException` - on error

### closeEntry

    public void closeEntry()
                    throws java.io.IOException

  Close an entry. This method MUST be called for all file entries that contain data. The reason is that we must buffer data written to the stream in order to satisfy the buffer's record based writes. Thus, there may be data fragments still being assembled that must be written to the output stream before this entry is closed and the next entry written.

  Throws:
    `java.io.IOException` - on error

### write

    public void write(int b)
               throws java.io.IOException

  Writes a byte to the current tar archive entry. This method simply calls read( byte[], int, int ).

  Overrides:
    `write` in class `java.io.FilterOutputStream`
  Parameters:
    `b` - The byte written.
  Throws:
    `java.io.IOException` - on error

### write

    public void write(byte[] wBuf)
               throws java.io.IOException

  Writes bytes to the current tar archive entry. This method simply calls write( byte[], int, int ).

  Overrides:
    `write` in class `java.io.FilterOutputStream`
  Parameters:
    `wBuf` - The buffer to write to the archive.
  Throws:
    `java.io.IOException` - on error

### write

    public void write(byte[] wBuf,
                      int wOffset,
                      int numToWrite)
               throws java.io.IOException

  Writes bytes to the current tar archive entry. This method is aware of the current entry and will throw an exception if you attempt to write bytes past the length specified for the current entry. The method is also (painfully) aware of the record buffering required by TarBuffer, and manages buffers that are not a multiple of recordsize in length, including assembling records from small buffers.

  Overrides:
    `write` in class `java.io.FilterOutputStream`
  Parameters:
    `wBuf` - The buffer to write to the archive.
    `wOffset` - The offset in the buffer from which to get bytes.
    `numToWrite` - The number of bytes to write.
  Throws:
    `java.io.IOException` - on error

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD